/// <reference path="../../definitions/q/Q.d.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var cmdm = require('../lib/tfcommand');
var params = require('../lib/parameternames');
var Q = require('q');
var trace = require('../lib/trace');
function describe() {
    return 'delete a build task';
}
exports.describe = describe;
function getArguments() {
    return cmdm.formatArgumentsHint([params.GENERIC_ID], []);
}
exports.getArguments = getArguments;
function getCommand() {
    return new BuildTaskDelete();
}
exports.getCommand = getCommand;
// requires auth, connect etc...
exports.isServerOperation = true;
// unless you have a good reason, should not hide
exports.hideBanner = false;
var BuildTaskDelete = (function (_super) {
    __extends(BuildTaskDelete, _super);
    function BuildTaskDelete() {
        _super.apply(this, arguments);
    }
    BuildTaskDelete.prototype.exec = function (args, options) {
        trace("build-tasks-delete.exec");
        var deferred = Q.defer();
        var taskId = args[0] || options[params.GENERIC_ID];
        this.checkRequiredParameter(taskId, params.GENERIC_ID, params.TASK_ID);
        trace("Initializing agent API...");
        var agentapi = this.getWebApi().getTaskAgentApi(this.connection.accountUrl);
        trace("Searching for tasks with id: " + taskId);
        agentapi.getTaskContent(taskId, "", function (err, statusCode, tasks) {
            trace("Found " + tasks.length + " tasks with provided id.");
            if (tasks.length > 0) {
                trace("Deleting task(s)...");
                agentapi.deleteTaskDefinition(taskId, function (err, statusCode) {
                    if (err) {
                        trace("Call to TaskAgentApi.deleteTaskDefinition failed with code " + statusCode + ". Message: " + err.message);
                        err.statusCode = statusCode;
                        deferred.reject(err);
                    }
                    else {
                        trace("Success.");
                        deferred.resolve({
                            id: taskId
                        });
                    }
                });
            }
            else {
                trace("No task.");
                deferred.reject(new Error("No task found with provided ID: " + taskId));
            }
        });
        return deferred.promise;
    };
    BuildTaskDelete.prototype.output = function (data) {
        console.log('task: ' + data.id + ' deleted successfully!');
    };
    return BuildTaskDelete;
})(cmdm.TfCommand);
exports.BuildTaskDelete = BuildTaskDelete;
